Subject: Re: How to resolve conflict: Moved away vs. created new file with same name

From: Johannes Sixt <[email-masked]>
Date: Tue, 19 Jan 2010 12:55:23 +0100

Johannes Schneider schrieb:
> TopicA:
> 
> created a directory "client" containing a pom.xml and several source files.
> 
> 
> TopicB:
> 
> created a directory "client" containing a pom.xml (different file than
> the one in TopicA).
> Created several subdirectories (client1, client2).
> 
> ...
> So I am trying to mimic the change in TopicA:
> 
> cd client
> mkdir client3
> mv pom.xml client3
> mv src client3
> ...commit...

Did you do this during the merge? If not, go back to TopicA and redo it;
then you avoid the conflict during the merge.

> Okay, so far so good. Now I try to merge TopicA and TopicB which fails.
> Of course Git doesn't understand that "client/pom.xml" in TopicA and
> TopicB are not related.
> I want to end with to the file from TopicA ending in
> "client/client3/pom.xml" and the file from TopicB in "client/pom.xml".

During the merge without the fixup suggested above:

git rm -f client/client3/pom.xml
git checkout TopicA -- client/pom.xml
git mv client/pom.xml client/client3/pom.xml
git checkout TopicB -- client/pom.xml

but it leaves you with an ugly history, and it would be far better to fix
up TopicA before the merge.

-- Hannes